﻿using Infragistics.Graphics;
using Infragistics.Portable.Components.Data;
using Infragistics.Win.DataVisualization;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WFGeographicMapImages
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            UltraGeographicMap map = new UltraGeographicMap();            

            List<Infragistics.Win.DataVisualization.Point> points = new List<Infragistics.Win.DataVisualization.Point>();

            Infragistics.Win.DataVisualization.Point point1 = new Infragistics.Win.DataVisualization.Point(51.5074, -0.1278);
            Infragistics.Win.DataVisualization.Point point2 = new Infragistics.Win.DataVisualization.Point(40.7128, -74.0060);
            Infragistics.Win.DataVisualization.Point point3 = new Infragistics.Win.DataVisualization.Point(-33.8688, 151.2093);
            Infragistics.Win.DataVisualization.Point point4 = new Infragistics.Win.DataVisualization.Point(-22.9068, -43.1729);

            points.Add(point1);
            points.Add(point2);
            points.Add(point3);
            points.Add(point4);

            CustomRenderTemplate template = new CustomRenderTemplate();
            template.Render = new DataTemplateRenderHandler(templateRenderHandler);
            template.Measure = new DataTemplateMeasureHandler(templateMeasureHandler);

            GeographicSymbolSeries series = new GeographicSymbolSeries()
            {
                DataSource = points,
                LatitudeMemberPath = "X",
                LongitudeMemberPath = "Y",
                MarkerTemplate = template
            };

            map.Series.Add(series);

            this.Controls.Add(map);            
        }

        public void templateMeasureHandler(DataTemplateMeasureInfo info)
        {
            info.Height = 12;
            info.Width = 12;
        }

        private void templateRenderHandler(DataTemplateRenderInfo info)
        {
            System.Drawing.Graphics graphics = info.Context as System.Drawing.Graphics;

            PropertyInfo propInfo = info.Data.GetType().GetProperty("Item");
            ShapefileRecord record = propInfo.GetValue(info.Data, null) as ShapefileRecord;

            if (graphics != null)
            {
                graphics.DrawImage(Image.FromFile("../../Images/DownArrow.png"), (float)info.XPosition - 6, (float)info.YPosition - 6, 12, 12);                
            }
        }
    }
}
